+++
title = "scan to samba share with HP Officejet pro 8600"
date = "2014-03-16T10:28:12+00:00"
author = "Gibheer"
draft = false
+++

Yesterday I bought a printer/scanner combination, a HP Officejet pro 8600. It
has some nice functions included, but the most important for us was the ability
to print to a network storage.
As I did not find any documentation on how it is possible to get the printer to
speak with a samba share, I will describe it here.

To get started I assume, that you already have a configured and running samba
server.

The first step is to create a new system user and group. This user will used to
create a login on the samba server for the scanner. The group will hold all users
which should have access to the scanned documents. The following commands are for
freebsd, but there should be an equivalent for any other system (like useradd).

    pw groupadd -n scans
    pw useradd -n scans -u 10000 -c "login for scanner" -d /nonexistent -g scans -s /usr/sbin/nologin

We can already add the user to the samba user managament. Don't forget to set
a strong password.

    smbpasswd -a scans

As we have the group for all scan users, we can add every account which should
have access

    pw groupmod scans -m gibheer,stormwind

Now we need a directory to store the scans into. We make sure, that none other
than group members can modify data in that directory.

    zfs create rpool/export/scans
    chown scans:scans /export/scans
    chmod 770 /export/scans

Now that we have the system stuff done, we need to configure the share in the
samba config. Add and modify the following part

    [scans]
    comment = scan directory
    path = /export/scans
    writeable = yes
    create mode = 0660
    guest ok = no
    valid users = @scans

Now restart/reload the samba server and the share should be good to go.
The only thing left is to configure the scanner to use that share. I did it over
the webinterface. For that, go to `https://<yourscannerhere>/#hId-NetworkFolderAccounts`.
The we add a new network folder with the following data:

* display name: scans
* network path: 
* user name: scans
* password: <enter password>

In the next step, you can secure the network drive with a pin. In the third step
you can set the default scan settings and now you are done.
Safe and test the settings and everything should work fine. The first scan will
be named scan.pdf and all following have an id appended. Too bad there isn't a
setting to append a timestamp instead. But it is still very nice t o be able to
scan to a network device.
