+++
title = "link summary 2016/04/09"
date = "2016-04-10T23:00:00+00:00"
author = "Gibheer"
draft = false
+++

The last couple days I found a number of very interesting links. As some of them
might be interesting for others too, I will put them here with some short explanation.

Go
--

There is some really interesting development in the golang community to build
tools based on the provided compiler infrastructure to do various stuff with
your code. Some of these tools are:

* [depscheck by divan](https://github.com/divan/depscheck) ([through a blog post](https://divan.github.io/posts/leftpad_and_go/)) which checks the dependencies and prints some stats about these. It also recommends to move code from a dependency into the scanned code base, when the dependency only is a couple of lines of code.
* [interfacer by mvdan](https://github.com/mvdan/interfacer) which makes suggestions to replace specific types with interfaces.
* [go-simple by dominikh](https://github.com/dominikh/go-simple) which makes suggestions to simplify code

Another interesting post was done by Dave Cheney about [constant errors](http://dave.cheney.net/2016/04/07/constant-errors), where he explains how one could define an error constant and when to use these constants.

PostgreSQL
----------

As the progress on 9.6 is going forward, there some really interesting commits:

* [planning to succeed by Simon Riggs](http://blog.2ndquadrant.com/planning-to-succeed/)
* [vacuum process reporting explained by depesz](http://www.depesz.com/2016/03/22/waiting-for-9-6-add-simple-vacuum-progress-reporting/)
* [parallel query by Robert Haas](http://rhaas.blogspot.de/2016/03/parallel-query-is-getting-better-and.html)

Also Bruce Momjian made an interesting blog entry about the [layers of security](http://momjian.us/main/blogs/pgblog/2016.html#April_9_2016) in postgres. Where he shows in short the order and layers of security used in postgres.

Another great news for postgres is the open sourcing of [citusdb](https://www.citusdata.com/blog/17-ozgun-erdogan/403-citus-unforks-postgresql-goes-open-source) as an extension for postgres. This enables sharding of data onto multiple postgres instances and therefore parallel execution of statements.

And at last, there is a very interesting blog post on [bloat in postgres](https://compose.io/articles/postgresql-bloat-origins-monitoring-and-managing/) which largely happens in similar war on any database. The article shows some examples on how to find bloat and makes some suggestions on how to fix it.

Thats it for this entry. Have fun reading.
